<template>
  <div class="container mx-auto mt-5">
    <div class="w-full black-flexible1-customize">
      <lobby-entry-filter
        v-model:search="searchedGame"
        :menus="gameEntryTabMenus"
        @onFilterClicked="onFilter"
        @search-games="updateSearchResult"
      >
        <template v-if="allowCompany && !isProviderGames1" #slotProp>
          <lobby-render
            :loading="isLoading"
            :games="gameCollection"
            :grid="5"
            :gap="6"
            :show-staus="true"
            class-game-name="text-white"
          />
        </template>
      </lobby-entry-filter>
      <lobby-render
        v-if="!allowCompany || isProviderGames1"
        :loading="isLoading"
        :games="gameCollection"
        :is-has-group-title="true"
        :group-title="gameGroupTitle"
        class-game-name="text-white"
        :show-staus="true"
      />
    </div>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, ref, watch } from "vue";
import commonHelper from "../../../../utils/commonHelper";
import { useGameEntryComponent } from "@/composables/useTheme";
import { IGameEntryMenu, TabGameMenu } from "@/models/gameEntryFilter";
import { GameFilterRequest } from "@/models/bsiGameList";

export default defineComponent({
  setup() {
    const {
      isLoading,
      headerTab,
      initialGameEntry,
      searchedGame,
      handleSearchGame,
      getGameEntryFiltered,
      gameCollection,
      updateSearchResult,
      isProviderGames1,
    } = useGameEntryComponent();
    const { allowCompany } = commonHelper;
    const gameEntryTabMenus = computed(() => {
      const result: IGameEntryMenu[] = [
        {
          Menus: headerTab.value.map((item) => new TabGameMenu(item, "main")),
          IsSearchBox: false,
          Justify: "left",
          Theme: "common",
        },
        {
          Menus: [],
          IsSearchBox: true,
          Justify: "left",
          Theme: "main",
        },
      ];
      return result;
    });

    const gameGroupTitle = ref("Top Games");
    const onFilter = (request: GameFilterRequest) => {
      getGameEntryFiltered(request);
      gameGroupTitle.value =
        request.Value === "" ? request.Type : request.Value;
    };
    watch(
      () => searchedGame.value,
      () => {
        handleSearchGame();
      }
    );
    return {
      gameEntryTabMenus,
      searchedGame,
      onFilter,
      initialGameEntry,
      gameGroupTitle,
      isLoading,
      gameCollection,
      updateSearchResult,
      isProviderGames1,
      allowCompany,
    };
  },
});
</script>
<style lang="scss">
:root {
  --gf-background-color: var(--border);
  --new-text-color: white;
  --gf-text-active-color: white;
}
.theme-wrapper[theme-color="main_lightblue"] .grid .flex .flex {
  .game-tab-menu .flex {
    flex-direction: row;
    .game-tab-icon,
    .game-tab-icon-active {
      width: 1.25rem;
      height: auto;
    }
  }
  span {
    color: var(--text);
  }
}
.theme-wrapper[theme-color="main_lightblue"] .el-button.search-button span {
  color: white !important;
}
.black-flexible1-customize {
  .game-filter-bg {
    background-color: transparent;
  }
  position: relative;
  .grid.grid-cols-10 {
    grid-template-columns: repeat(12, minmax(0, 1fr));
  }
  .game-filter {
    margin-bottom: 15px;
  }
  .grid {
    margin-bottom: 15px;
    .col-span-2 {
      border: none;
      .cursor-pointer div {
        justify-content: center;
        // height: 38px;
      }
      .cursor-pointer img {
        width: 100%;
      }
    }
  }
  .grid .flex .flex {
    .game-tab-menu .flex {
      flex-direction: row;
      .game-tab-icon,
      .game-tab-icon-active {
        width: 1.25rem;
        height: auto;
      }
    }
    span {
      color: white;
    }
  }
  div .w-full.text-white {
    display: none;
  }
}
</style>
